/*
 *  vtgsymbolcompletionshell.vala - Vala developer toys for GEdit
 *  
 *  Copyright (C) 2008 - Andrea Del Signore <sejerpz@tin.it>
 *  
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *   
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *   
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330,
 *  Boston, MA 02111-1307, USA.
 */

#ifndef __VSCCOMPLETIONSHELL_H__
#define __VSCCOMPLETIONSHELL_H__

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>

G_BEGIN_DECLS


#define VSC_TYPE_COMPLETION_SHELL (vsc_completion_shell_get_type ())
#define VSC_COMPLETION_SHELL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VSC_TYPE_COMPLETION_SHELL, VscCompletionShell))
#define VSC_COMPLETION_SHELL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VSC_TYPE_COMPLETION_SHELL, VscCompletionShellClass))
#define VSC_IS_COMPLETION_SHELL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VSC_TYPE_COMPLETION_SHELL))
#define VSC_IS_COMPLETION_SHELL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VSC_TYPE_COMPLETION_SHELL))
#define VSC_COMPLETION_SHELL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VSC_TYPE_COMPLETION_SHELL, VscCompletionShellClass))

typedef struct _VscCompletionShell VscCompletionShell;
typedef struct _VscCompletionShellClass VscCompletionShellClass;
typedef struct _VscCompletionShellPrivate VscCompletionShellPrivate;

struct _VscCompletionShell {
	GObject parent_instance;
	VscCompletionShellPrivate * priv;
};

struct _VscCompletionShellClass {
	GObjectClass parent_class;
};


void vsc_completion_shell_run (VscCompletionShell* self, const char* script);
void vsc_completion_shell_print_error (VscCompletionShell* self, const char* message);
void vsc_completion_shell_print_message (VscCompletionShell* self, const char* message);
gint vsc_completion_shell_main (char** args, int args_length1);
VscCompletionShell* vsc_completion_shell_construct (GType object_type);
VscCompletionShell* vsc_completion_shell_new (void);
GType vsc_completion_shell_get_type (void);


G_END_DECLS

#endif
