/*
 *  vscmethodlistvisitor.vala - Vala symbol completion library
 *  
 *  Copyright (C) 2008 - Andrea Del Signore <sejerpz@tin.it>
 *  
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 */

#ifndef __VSCMETHODLISTVISITOR_H__
#define __VSCMETHODLISTVISITOR_H__

#include <glib.h>
#include <glib-object.h>
#include <vala/valacodevisitor.h>
#include <gee/list.h>
#include <vala/valasourcefile.h>
#include <vala/valanamespace.h>
#include <vala/valaclass.h>
#include <vala/valamethod.h>

G_BEGIN_DECLS


#define VSC_TYPE_METHOD_LIST (vsc_method_list_get_type ())
#define VSC_METHOD_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VSC_TYPE_METHOD_LIST, VscMethodList))
#define VSC_METHOD_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VSC_TYPE_METHOD_LIST, VscMethodListClass))
#define VSC_IS_METHOD_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VSC_TYPE_METHOD_LIST))
#define VSC_IS_METHOD_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VSC_TYPE_METHOD_LIST))
#define VSC_METHOD_LIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VSC_TYPE_METHOD_LIST, VscMethodListClass))

typedef struct _VscMethodList VscMethodList;
typedef struct _VscMethodListClass VscMethodListClass;
typedef struct _VscMethodListPrivate VscMethodListPrivate;

/**
 * Code visitor getting a list of methods for a source file
 */
struct _VscMethodList {
	ValaCodeVisitor parent_instance;
	VscMethodListPrivate * priv;
};

struct _VscMethodListClass {
	ValaCodeVisitorClass parent_class;
};


VscMethodList* vsc_method_list_construct (GType object_type, GeeList* methods);
VscMethodList* vsc_method_list_new (GeeList* methods);
GType vsc_method_list_get_type (void);


G_END_DECLS

#endif
