/*
 *  vscsourcebuffer.vala - Vala symbol completion library
 *  
 *  Copyright (C) 2008 - Andrea Del Signore <sejerpz@tin.it>
 *  
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 */

#ifndef __VSCSOURCEBUFFER_H__
#define __VSCSOURCEBUFFER_H__

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>

G_BEGIN_DECLS


#define VSC_TYPE_SOURCE_BUFFER (vsc_source_buffer_get_type ())
#define VSC_SOURCE_BUFFER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VSC_TYPE_SOURCE_BUFFER, VscSourceBuffer))
#define VSC_SOURCE_BUFFER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VSC_TYPE_SOURCE_BUFFER, VscSourceBufferClass))
#define VSC_IS_SOURCE_BUFFER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VSC_TYPE_SOURCE_BUFFER))
#define VSC_IS_SOURCE_BUFFER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VSC_TYPE_SOURCE_BUFFER))
#define VSC_SOURCE_BUFFER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VSC_TYPE_SOURCE_BUFFER, VscSourceBufferClass))

typedef struct _VscSourceBuffer VscSourceBuffer;
typedef struct _VscSourceBufferClass VscSourceBufferClass;
typedef struct _VscSourceBufferPrivate VscSourceBufferPrivate;

struct _VscSourceBuffer {
	GObject parent_instance;
	VscSourceBufferPrivate * priv;
};

struct _VscSourceBufferClass {
	GObjectClass parent_class;
};


VscSourceBuffer* vsc_source_buffer_construct (GType object_type, const char* name, const char* source);
VscSourceBuffer* vsc_source_buffer_new (const char* name, const char* source);
const char* vsc_source_buffer_get_name (VscSourceBuffer* self);
void vsc_source_buffer_set_name (VscSourceBuffer* self, const char* value);
const char* vsc_source_buffer_get_source (VscSourceBuffer* self);
void vsc_source_buffer_set_source (VscSourceBuffer* self, const char* value);
GType vsc_source_buffer_get_type (void);


G_END_DECLS

#endif
