/*
 *  vscsymbolcompletionfilteroptions.vala - Vala symbol completion library
 *  
 *  Copyright (C) 2008 - Andrea Del Signore <sejerpz@tin.it>
 *  
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 */

#ifndef __VSCSYMBOLCOMPLETIONFILTEROPTIONS_H__
#define __VSCSYMBOLCOMPLETIONFILTEROPTIONS_H__

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>

G_BEGIN_DECLS


#define VSC_TYPE_SYMBOL_COMPLETION_FILTER_OPTIONS (vsc_symbol_completion_filter_options_get_type ())
#define VSC_SYMBOL_COMPLETION_FILTER_OPTIONS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VSC_TYPE_SYMBOL_COMPLETION_FILTER_OPTIONS, VscSymbolCompletionFilterOptions))
#define VSC_SYMBOL_COMPLETION_FILTER_OPTIONS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VSC_TYPE_SYMBOL_COMPLETION_FILTER_OPTIONS, VscSymbolCompletionFilterOptionsClass))
#define VSC_IS_SYMBOL_COMPLETION_FILTER_OPTIONS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VSC_TYPE_SYMBOL_COMPLETION_FILTER_OPTIONS))
#define VSC_IS_SYMBOL_COMPLETION_FILTER_OPTIONS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VSC_TYPE_SYMBOL_COMPLETION_FILTER_OPTIONS))
#define VSC_SYMBOL_COMPLETION_FILTER_OPTIONS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VSC_TYPE_SYMBOL_COMPLETION_FILTER_OPTIONS, VscSymbolCompletionFilterOptionsClass))

typedef struct _VscSymbolCompletionFilterOptions VscSymbolCompletionFilterOptions;
typedef struct _VscSymbolCompletionFilterOptionsClass VscSymbolCompletionFilterOptionsClass;
typedef struct _VscSymbolCompletionFilterOptionsPrivate VscSymbolCompletionFilterOptionsPrivate;
typedef struct _VscParamSpecSymbolCompletionFilterOptions VscParamSpecSymbolCompletionFilterOptions;

struct _VscSymbolCompletionFilterOptions {
	GTypeInstance parent_instance;
	volatile int ref_count;
	VscSymbolCompletionFilterOptionsPrivate * priv;
	gboolean static_symbols;
	gboolean interface_symbols;
	gboolean constructors;
	gboolean instance_symbols;
	gboolean imported_namespaces;
	gboolean local_variables;
	gboolean error_domains;
	gboolean error_base;
	gboolean private_symbols;
	gboolean public_symbols;
	gboolean protected_symbols;
	gboolean internal_symbols;
	char* exclude_type;
};

struct _VscSymbolCompletionFilterOptionsClass {
	GTypeClass parent_class;
	void (*finalize) (VscSymbolCompletionFilterOptions *self);
};

struct _VscParamSpecSymbolCompletionFilterOptions {
	GParamSpec parent_instance;
};


VscSymbolCompletionFilterOptions* vsc_symbol_completion_filter_options_construct (GType object_type);
VscSymbolCompletionFilterOptions* vsc_symbol_completion_filter_options_new (void);
void vsc_symbol_completion_filter_options_defaults (VscSymbolCompletionFilterOptions* self);
void vsc_symbol_completion_filter_options_public_only (VscSymbolCompletionFilterOptions* self);
GParamSpec* vsc_param_spec_symbol_completion_filter_options (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
gpointer vsc_value_get_symbol_completion_filter_options (const GValue* value);
void vsc_value_set_symbol_completion_filter_options (GValue* value, gpointer v_object);
GType vsc_symbol_completion_filter_options_get_type (void);
gpointer vsc_symbol_completion_filter_options_ref (gpointer instance);
void vsc_symbol_completion_filter_options_unref (gpointer instance);


G_END_DECLS

#endif
