/*
 *  vtgbracketcompletion.vala - Vala developer toys for GEdit
 *  
 *  Copyright (C) 2008 - Andrea Del Signore <sejerpz@tin.it>
 *  
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *   
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *   
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330,
 *  Boston, MA 02111-1307, USA.
 */

#ifndef __VTGBRACKETCOMPLETION_H__
#define __VTGBRACKETCOMPLETION_H__

#include <glib.h>
#include <glib-object.h>
#include <gedit/gedit-view.h>
#include "vtgplugin.h"

G_BEGIN_DECLS


#define VTG_TYPE_BRACKET_COMPLETION (vtg_bracket_completion_get_type ())
#define VTG_BRACKET_COMPLETION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VTG_TYPE_BRACKET_COMPLETION, VtgBracketCompletion))
#define VTG_BRACKET_COMPLETION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VTG_TYPE_BRACKET_COMPLETION, VtgBracketCompletionClass))
#define VTG_IS_BRACKET_COMPLETION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VTG_TYPE_BRACKET_COMPLETION))
#define VTG_IS_BRACKET_COMPLETION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VTG_TYPE_BRACKET_COMPLETION))
#define VTG_BRACKET_COMPLETION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VTG_TYPE_BRACKET_COMPLETION, VtgBracketCompletionClass))

typedef struct _VtgBracketCompletion VtgBracketCompletion;
typedef struct _VtgBracketCompletionClass VtgBracketCompletionClass;
typedef struct _VtgBracketCompletionPrivate VtgBracketCompletionPrivate;

struct _VtgBracketCompletion {
	GObject parent_instance;
	VtgBracketCompletionPrivate * priv;
};

struct _VtgBracketCompletionClass {
	GObjectClass parent_class;
};


VtgBracketCompletion* vtg_bracket_completion_construct (GType object_type, VtgPlugin* plugin, GeditView* view);
VtgBracketCompletion* vtg_bracket_completion_new (VtgPlugin* plugin, GeditView* view);
void vtg_bracket_completion_deactivate (VtgBracketCompletion* self);
VtgPlugin* vtg_bracket_completion_get_plugin (VtgBracketCompletion* self);
GeditView* vtg_bracket_completion_get_view (VtgBracketCompletion* self);
GType vtg_bracket_completion_get_type (void);
GType vtg_bracket_completion_register_type (GTypeModule * module);


G_END_DECLS

#endif
