/*
 *  vtgconfigurationdialog.vala - Vala developer toys for GEdit
 *  
 *  Copyright (C) 2008 - Andrea Del Signore <sejerpz@tin.it>
 *  
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *   
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *   
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330,
 *  Boston, MA 02111-1307, USA.
 */

#ifndef __VTGCONFIGURATION_H__
#define __VTGCONFIGURATION_H__

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>

G_BEGIN_DECLS


#define VTG_TYPE_CONFIGURATION (vtg_configuration_get_type ())
#define VTG_CONFIGURATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VTG_TYPE_CONFIGURATION, VtgConfiguration))
#define VTG_CONFIGURATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VTG_TYPE_CONFIGURATION, VtgConfigurationClass))
#define VTG_IS_CONFIGURATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VTG_TYPE_CONFIGURATION))
#define VTG_IS_CONFIGURATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VTG_TYPE_CONFIGURATION))
#define VTG_CONFIGURATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VTG_TYPE_CONFIGURATION, VtgConfigurationClass))

typedef struct _VtgConfiguration VtgConfiguration;
typedef struct _VtgConfigurationClass VtgConfigurationClass;
typedef struct _VtgConfigurationPrivate VtgConfigurationPrivate;

struct _VtgConfiguration {
	GObject parent_instance;
	VtgConfigurationPrivate * priv;
};

struct _VtgConfigurationClass {
	GObjectClass parent_class;
};


GtkWidget* vtg_configuration_get_configuration_dialog (VtgConfiguration* self);
VtgConfiguration* vtg_configuration_construct (GType object_type);
VtgConfiguration* vtg_configuration_new (void);
gboolean vtg_configuration_get_bracket_enabled (VtgConfiguration* self);
void vtg_configuration_set_bracket_enabled (VtgConfiguration* self, gboolean value);
gboolean vtg_configuration_get_symbol_enabled (VtgConfiguration* self);
void vtg_configuration_set_symbol_enabled (VtgConfiguration* self, gboolean value);
const char* vtg_configuration_get_author (VtgConfiguration* self);
void vtg_configuration_set_author (VtgConfiguration* self, const char* value);
const char* vtg_configuration_get_email_address (VtgConfiguration* self);
void vtg_configuration_set_email_address (VtgConfiguration* self, const char* value);
gboolean vtg_configuration_get_save_before_build (VtgConfiguration* self);
GType vtg_configuration_get_type (void);
GType vtg_configuration_register_type (GTypeModule * module);


G_END_DECLS

#endif
