/*
 *  vtgparametersdialog.vala - Vala developer toys for GEdit
 *  
 *  Copyright (C) 2008 - Andrea Del Signore <sejerpz@tin.it>
 *  
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *   
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *   
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330,
 *  Boston, MA 02111-1307, USA.
 */

#ifndef __VTGPARAMETERSDIALOG_H__
#define __VTGPARAMETERSDIALOG_H__

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>

G_BEGIN_DECLS


#define VTG_INTERACTION_TYPE_PARAMETERS_DIALOG (vtg_interaction_parameters_dialog_get_type ())
#define VTG_INTERACTION_PARAMETERS_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VTG_INTERACTION_TYPE_PARAMETERS_DIALOG, VtgInteractionParametersDialog))
#define VTG_INTERACTION_PARAMETERS_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VTG_INTERACTION_TYPE_PARAMETERS_DIALOG, VtgInteractionParametersDialogClass))
#define VTG_INTERACTION_IS_PARAMETERS_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VTG_INTERACTION_TYPE_PARAMETERS_DIALOG))
#define VTG_INTERACTION_IS_PARAMETERS_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VTG_INTERACTION_TYPE_PARAMETERS_DIALOG))
#define VTG_INTERACTION_PARAMETERS_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VTG_INTERACTION_TYPE_PARAMETERS_DIALOG, VtgInteractionParametersDialogClass))

typedef struct _VtgInteractionParametersDialog VtgInteractionParametersDialog;
typedef struct _VtgInteractionParametersDialogClass VtgInteractionParametersDialogClass;
typedef struct _VtgInteractionParametersDialogPrivate VtgInteractionParametersDialogPrivate;
typedef struct _VtgInteractionParamSpecParametersDialog VtgInteractionParamSpecParametersDialog;

struct _VtgInteractionParametersDialog {
	GTypeInstance parent_instance;
	volatile int ref_count;
	VtgInteractionParametersDialogPrivate * priv;
};

struct _VtgInteractionParametersDialogClass {
	GTypeClass parent_class;
	void (*finalize) (VtgInteractionParametersDialog *self);
};

struct _VtgInteractionParamSpecParametersDialog {
	GParamSpec parent_instance;
};


VtgInteractionParametersDialog* vtg_interaction_parameters_dialog_construct (GType object_type, const char* title, GtkWindow* parent, GtkListStore* completions);
VtgInteractionParametersDialog* vtg_interaction_parameters_dialog_new (const char* title, GtkWindow* parent, GtkListStore* completions);
gint vtg_interaction_parameters_dialog_run (VtgInteractionParametersDialog* self);
const char* vtg_interaction_parameters_dialog_get_parameters (VtgInteractionParametersDialog* self);
GParamSpec* vtg_interaction_param_spec_parameters_dialog (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
gpointer vtg_interaction_value_get_parameters_dialog (const GValue* value);
void vtg_interaction_value_set_parameters_dialog (GValue* value, gpointer v_object);
GType vtg_interaction_parameters_dialog_get_type (void);
GType vtg_interaction_parameters_dialog_register_type (GTypeModule * module);
gpointer vtg_interaction_parameters_dialog_ref (gpointer instance);
void vtg_interaction_parameters_dialog_unref (gpointer instance);


G_END_DECLS

#endif
