/*
 *  vtgprojectmanager.vala - Vala developer toys for GEdit
 *  
 *  Copyright (C) 2008 - Andrea Del Signore <sejerpz@tin.it>
 *  
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *   
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *   
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330,
 *  Boston, MA 02111-1307, USA.
 */

#ifndef __VTGPROJECTMANAGER_H__
#define __VTGPROJECTMANAGER_H__

#include <glib.h>
#include <glib-object.h>
#include "vtgplugin.h"

G_BEGIN_DECLS


#define VTG_PROJECT_MANAGER_TYPE_PLUGIN_HELPER (vtg_project_manager_plugin_helper_get_type ())
#define VTG_PROJECT_MANAGER_PLUGIN_HELPER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VTG_PROJECT_MANAGER_TYPE_PLUGIN_HELPER, VtgProjectManagerPluginHelper))
#define VTG_PROJECT_MANAGER_PLUGIN_HELPER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VTG_PROJECT_MANAGER_TYPE_PLUGIN_HELPER, VtgProjectManagerPluginHelperClass))
#define VTG_PROJECT_MANAGER_IS_PLUGIN_HELPER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VTG_PROJECT_MANAGER_TYPE_PLUGIN_HELPER))
#define VTG_PROJECT_MANAGER_IS_PLUGIN_HELPER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VTG_PROJECT_MANAGER_TYPE_PLUGIN_HELPER))
#define VTG_PROJECT_MANAGER_PLUGIN_HELPER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VTG_PROJECT_MANAGER_TYPE_PLUGIN_HELPER, VtgProjectManagerPluginHelperClass))

typedef struct _VtgProjectManagerPluginHelperPrivate VtgProjectManagerPluginHelperPrivate;

struct _VtgProjectManagerPluginHelper {
	GObject parent_instance;
	VtgProjectManagerPluginHelperPrivate * priv;
};

struct _VtgProjectManagerPluginHelperClass {
	GObjectClass parent_class;
};


VtgProjectManagerPluginHelper* vtg_project_manager_plugin_helper_construct (GType object_type, VtgPlugin* plugin);
VtgProjectManagerPluginHelper* vtg_project_manager_plugin_helper_new (VtgPlugin* plugin);
void vtg_project_manager_plugin_helper_deactivate (VtgProjectManagerPluginHelper* self);
VtgPlugin* vtg_project_manager_plugin_helper_get_plugin (VtgProjectManagerPluginHelper* self);
VtgProjectManagerView* vtg_project_manager_plugin_helper_get_project_view (VtgProjectManagerPluginHelper* self);
GType vtg_project_manager_plugin_helper_get_type (void);
GType vtg_project_manager_plugin_helper_register_type (GTypeModule * module);


G_END_DECLS

#endif
