/*
 *  vtgprojectmanagerbuildlogview.vala - Vala developer toys for GEdit
 *  
 *  Copyright (C) 2008 - Andrea Del Signore <sejerpz@tin.it>
 *  
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *   
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *   
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330,
 *  Boston, MA 02111-1307, USA.
 */

#ifndef __VTGPROJECTMANAGERBUILDLOGVIEW_H__
#define __VTGPROJECTMANAGERBUILDLOGVIEW_H__

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include "vtgplugin.h"
#include "vtgprojectmanagerproject.h"
#include "vtgprojectmanageroutputview.h"

G_BEGIN_DECLS


#define VTG_PROJECT_MANAGER_TYPE_BUILD_LOG_VIEW (vtg_project_manager_build_log_view_get_type ())
#define VTG_PROJECT_MANAGER_BUILD_LOG_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VTG_PROJECT_MANAGER_TYPE_BUILD_LOG_VIEW, VtgProjectManagerBuildLogView))
#define VTG_PROJECT_MANAGER_BUILD_LOG_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VTG_PROJECT_MANAGER_TYPE_BUILD_LOG_VIEW, VtgProjectManagerBuildLogViewClass))
#define VTG_PROJECT_MANAGER_IS_BUILD_LOG_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VTG_PROJECT_MANAGER_TYPE_BUILD_LOG_VIEW))
#define VTG_PROJECT_MANAGER_IS_BUILD_LOG_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VTG_PROJECT_MANAGER_TYPE_BUILD_LOG_VIEW))
#define VTG_PROJECT_MANAGER_BUILD_LOG_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VTG_PROJECT_MANAGER_TYPE_BUILD_LOG_VIEW, VtgProjectManagerBuildLogViewClass))

typedef struct _VtgProjectManagerBuildLogView VtgProjectManagerBuildLogView;
typedef struct _VtgProjectManagerBuildLogViewClass VtgProjectManagerBuildLogViewClass;
typedef struct _VtgProjectManagerBuildLogViewPrivate VtgProjectManagerBuildLogViewPrivate;

struct _VtgProjectManagerBuildLogView {
	GObject parent_instance;
	VtgProjectManagerBuildLogViewPrivate * priv;
};

struct _VtgProjectManagerBuildLogViewClass {
	GObjectClass parent_class;
};


VtgProjectManagerBuildLogView* vtg_project_manager_build_log_view_construct (GType object_type, VtgPlugin* plugin);
VtgProjectManagerBuildLogView* vtg_project_manager_build_log_view_new (VtgPlugin* plugin);
void vtg_project_manager_build_log_view_initialize (VtgProjectManagerBuildLogView* self, VtgProjectManagerProject* project);
void vtg_project_manager_build_log_view_activate (VtgProjectManagerBuildLogView* self);
gboolean vtg_project_manager_build_log_view_on_message_added (VtgProjectManagerBuildLogView* self, VtgProjectManagerOutputView* sender, const char* message);
void vtg_project_manager_build_log_view_on_build_view_row_activated (VtgProjectManagerBuildLogView* self, GtkWidget* sender, const GtkTreePath* path, GtkTreeViewColumn* column);
void vtg_project_manager_build_log_view_next_error (VtgProjectManagerBuildLogView* self);
void vtg_project_manager_build_log_view_previous_error (VtgProjectManagerBuildLogView* self);
VtgPlugin* vtg_project_manager_build_log_view_get_plugin (VtgProjectManagerBuildLogView* self);
gint vtg_project_manager_build_log_view_get_error_count (VtgProjectManagerBuildLogView* self);
GType vtg_project_manager_build_log_view_get_type (void);
GType vtg_project_manager_build_log_view_register_type (GTypeModule * module);


G_END_DECLS

#endif
