/*
 *  vtgprojectmanagerexecuter.vala - Vala developer toys for GEdit
 *  
 *  Copyright (C) 2008 - Andrea Del Signore <sejerpz@tin.it>
 *  
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *   
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *   
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330,
 *  Boston, MA 02111-1307, USA.
 */

#ifndef __VTGPROJECTMANAGEREXECUTER_H__
#define __VTGPROJECTMANAGEREXECUTER_H__

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include "vtgplugin.h"
#include "vtgprojectmanagerproject.h"

G_BEGIN_DECLS


#define VTG_PROJECT_MANAGER_TYPE_EXECUTER (vtg_project_manager_executer_get_type ())
#define VTG_PROJECT_MANAGER_EXECUTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VTG_PROJECT_MANAGER_TYPE_EXECUTER, VtgProjectManagerExecuter))
#define VTG_PROJECT_MANAGER_EXECUTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VTG_PROJECT_MANAGER_TYPE_EXECUTER, VtgProjectManagerExecuterClass))
#define VTG_PROJECT_MANAGER_IS_EXECUTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VTG_PROJECT_MANAGER_TYPE_EXECUTER))
#define VTG_PROJECT_MANAGER_IS_EXECUTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VTG_PROJECT_MANAGER_TYPE_EXECUTER))
#define VTG_PROJECT_MANAGER_EXECUTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VTG_PROJECT_MANAGER_TYPE_EXECUTER, VtgProjectManagerExecuterClass))

typedef struct _VtgProjectManagerExecuter VtgProjectManagerExecuter;
typedef struct _VtgProjectManagerExecuterClass VtgProjectManagerExecuterClass;
typedef struct _VtgProjectManagerExecuterPrivate VtgProjectManagerExecuterPrivate;

struct _VtgProjectManagerExecuter {
	GObject parent_instance;
	VtgProjectManagerExecuterPrivate * priv;
};

struct _VtgProjectManagerExecuterClass {
	GObjectClass parent_class;
};


VtgProjectManagerExecuter* vtg_project_manager_executer_construct (GType object_type, VtgPlugin* plugin);
VtgProjectManagerExecuter* vtg_project_manager_executer_new (VtgPlugin* plugin);
gboolean vtg_project_manager_executer_execute (VtgProjectManagerExecuter* self, VtgProjectManagerProject* project, const char* command_line);
void vtg_project_manager_executer_kill_last (VtgProjectManagerExecuter* self);
VtgPlugin* vtg_project_manager_executer_get_plugin (VtgProjectManagerExecuter* self);
gboolean vtg_project_manager_executer_get_is_executing (VtgProjectManagerExecuter* self);
GType vtg_project_manager_executer_get_type (void);
GType vtg_project_manager_executer_register_type (GTypeModule * module);


G_END_DECLS

#endif
