/*
 *  vtgprojectexecuterdialog.vala - Vala developer toys for GEdit
 *  
 *  Copyright (C) 2008 - Andrea Del Signore <sejerpz@tin.it>
 *  
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *   
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *   
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330,
 *  Boston, MA 02111-1307, USA.
 */

#ifndef __VTGPROJECTMANAGEREXECUTERDIALOG_H__
#define __VTGPROJECTMANAGEREXECUTERDIALOG_H__

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include "vtgprojectmanagerproject.h"

G_BEGIN_DECLS


#define VTG_PROJECT_MANAGER_TYPE_EXECUTER_DIALOG (vtg_project_manager_executer_dialog_get_type ())
#define VTG_PROJECT_MANAGER_EXECUTER_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VTG_PROJECT_MANAGER_TYPE_EXECUTER_DIALOG, VtgProjectManagerExecuterDialog))
#define VTG_PROJECT_MANAGER_EXECUTER_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VTG_PROJECT_MANAGER_TYPE_EXECUTER_DIALOG, VtgProjectManagerExecuterDialogClass))
#define VTG_PROJECT_MANAGER_IS_EXECUTER_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VTG_PROJECT_MANAGER_TYPE_EXECUTER_DIALOG))
#define VTG_PROJECT_MANAGER_IS_EXECUTER_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VTG_PROJECT_MANAGER_TYPE_EXECUTER_DIALOG))
#define VTG_PROJECT_MANAGER_EXECUTER_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VTG_PROJECT_MANAGER_TYPE_EXECUTER_DIALOG, VtgProjectManagerExecuterDialogClass))

typedef struct _VtgProjectManagerExecuterDialog VtgProjectManagerExecuterDialog;
typedef struct _VtgProjectManagerExecuterDialogClass VtgProjectManagerExecuterDialogClass;
typedef struct _VtgProjectManagerExecuterDialogPrivate VtgProjectManagerExecuterDialogPrivate;
typedef struct _VtgProjectManagerParamSpecExecuterDialog VtgProjectManagerParamSpecExecuterDialog;

struct _VtgProjectManagerExecuterDialog {
	GTypeInstance parent_instance;
	volatile int ref_count;
	VtgProjectManagerExecuterDialogPrivate * priv;
};

struct _VtgProjectManagerExecuterDialogClass {
	GTypeClass parent_class;
	void (*finalize) (VtgProjectManagerExecuterDialog *self);
};

struct _VtgProjectManagerParamSpecExecuterDialog {
	GParamSpec parent_instance;
};


VtgProjectManagerExecuterDialog* vtg_project_manager_executer_dialog_construct (GType object_type, GtkWindow* parent, VtgProjectManagerProject* project);
VtgProjectManagerExecuterDialog* vtg_project_manager_executer_dialog_new (GtkWindow* parent, VtgProjectManagerProject* project);
gint vtg_project_manager_executer_dialog_run (VtgProjectManagerExecuterDialog* self);
const char* vtg_project_manager_executer_dialog_get_command_line (VtgProjectManagerExecuterDialog* self);
GParamSpec* vtg_project_manager_param_spec_executer_dialog (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
gpointer vtg_project_manager_value_get_executer_dialog (const GValue* value);
void vtg_project_manager_value_set_executer_dialog (GValue* value, gpointer v_object);
GType vtg_project_manager_executer_dialog_get_type (void);
GType vtg_project_manager_executer_dialog_register_type (GTypeModule * module);
gpointer vtg_project_manager_executer_dialog_ref (gpointer instance);
void vtg_project_manager_executer_dialog_unref (gpointer instance);


G_END_DECLS

#endif
