/*
 *  vtgprojectmanagerfilteredlistdialog.vala - Vala developer toys for GEdit
 *  
 *  Copyright (C) 2008 - Andrea Del Signore <sejerpz@tin.it>
 *  
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *   
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *   
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330,
 *  Boston, MA 02111-1307, USA.
 */

#ifndef __VTGPROJECTMANAGERFILTEREDLISTDIALOG_H__
#define __VTGPROJECTMANAGERFILTEREDLISTDIALOG_H__

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>

G_BEGIN_DECLS


#define VTG_PROJECT_MANAGER_TYPE_FILTERED_LIST_DIALOG (vtg_project_manager_filtered_list_dialog_get_type ())
#define VTG_PROJECT_MANAGER_FILTERED_LIST_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VTG_PROJECT_MANAGER_TYPE_FILTERED_LIST_DIALOG, VtgProjectManagerFilteredListDialog))
#define VTG_PROJECT_MANAGER_FILTERED_LIST_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VTG_PROJECT_MANAGER_TYPE_FILTERED_LIST_DIALOG, VtgProjectManagerFilteredListDialogClass))
#define VTG_PROJECT_MANAGER_IS_FILTERED_LIST_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VTG_PROJECT_MANAGER_TYPE_FILTERED_LIST_DIALOG))
#define VTG_PROJECT_MANAGER_IS_FILTERED_LIST_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VTG_PROJECT_MANAGER_TYPE_FILTERED_LIST_DIALOG))
#define VTG_PROJECT_MANAGER_FILTERED_LIST_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VTG_PROJECT_MANAGER_TYPE_FILTERED_LIST_DIALOG, VtgProjectManagerFilteredListDialogClass))

typedef struct _VtgProjectManagerFilteredListDialog VtgProjectManagerFilteredListDialog;
typedef struct _VtgProjectManagerFilteredListDialogClass VtgProjectManagerFilteredListDialogClass;
typedef struct _VtgProjectManagerFilteredListDialogPrivate VtgProjectManagerFilteredListDialogPrivate;

struct _VtgProjectManagerFilteredListDialog {
	GObject parent_instance;
	VtgProjectManagerFilteredListDialogPrivate * priv;
	GtkTreeIter selected_iter;
};

struct _VtgProjectManagerFilteredListDialogClass {
	GObjectClass parent_class;
};


VtgProjectManagerFilteredListDialog* vtg_project_manager_filtered_list_dialog_construct (GType object_type, GtkTreeModel* model);
VtgProjectManagerFilteredListDialog* vtg_project_manager_filtered_list_dialog_new (GtkTreeModel* model);
gboolean vtg_project_manager_filtered_list_dialog_run (VtgProjectManagerFilteredListDialog* self);
gboolean vtg_project_manager_filtered_list_dialog_on_entry_key_press (VtgProjectManagerFilteredListDialog* self, GtkWidget* sender, const GdkEventKey* evt);
gboolean vtg_project_manager_filtered_list_dialog_on_treeview_key_press (VtgProjectManagerFilteredListDialog* self, GtkWidget* sender, const GdkEventKey* evt);
GType vtg_project_manager_filtered_list_dialog_get_type (void);
GType vtg_project_manager_filtered_list_dialog_register_type (GTypeModule * module);


G_END_DECLS

#endif
