/*
 *  vtgprojectmanageroutputview.vala - Vala developer toys for GEdit
 *  
 *  Copyright (C) 2008 - Andrea Del Signore <sejerpz@tin.it>
 *  
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *   
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *   
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330,
 *  Boston, MA 02111-1307, USA.
 */

#ifndef __VTGPROJECTMANAGEROUTPUTVIEW_H__
#define __VTGPROJECTMANAGEROUTPUTVIEW_H__

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include "vtgplugin.h"

G_BEGIN_DECLS


#define VTG_PROJECT_MANAGER_TYPE_OUTPUT_VIEW (vtg_project_manager_output_view_get_type ())
#define VTG_PROJECT_MANAGER_OUTPUT_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VTG_PROJECT_MANAGER_TYPE_OUTPUT_VIEW, VtgProjectManagerOutputView))
#define VTG_PROJECT_MANAGER_OUTPUT_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VTG_PROJECT_MANAGER_TYPE_OUTPUT_VIEW, VtgProjectManagerOutputViewClass))
#define VTG_PROJECT_MANAGER_IS_OUTPUT_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VTG_PROJECT_MANAGER_TYPE_OUTPUT_VIEW))
#define VTG_PROJECT_MANAGER_IS_OUTPUT_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VTG_PROJECT_MANAGER_TYPE_OUTPUT_VIEW))
#define VTG_PROJECT_MANAGER_OUTPUT_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VTG_PROJECT_MANAGER_TYPE_OUTPUT_VIEW, VtgProjectManagerOutputViewClass))

typedef struct _VtgProjectManagerOutputViewPrivate VtgProjectManagerOutputViewPrivate;

struct _VtgProjectManagerOutputView {
	GObject parent_instance;
	VtgProjectManagerOutputViewPrivate * priv;
	VtgPlugin* _plugin;
};

struct _VtgProjectManagerOutputViewClass {
	GObjectClass parent_class;
	void (*start_watch) (VtgProjectManagerOutputView* self, guint id, gint stdo, gint stde, gint stdi);
	void (*stop_watch) (VtgProjectManagerOutputView* self, guint id);
};


VtgProjectManagerOutputView* vtg_project_manager_output_view_construct (GType object_type, VtgPlugin* plugin);
VtgProjectManagerOutputView* vtg_project_manager_output_view_new (VtgPlugin* plugin);
void vtg_project_manager_output_view_start_watch (VtgProjectManagerOutputView* self, guint id, gint stdo, gint stde, gint stdi);
void vtg_project_manager_output_view_stop_watch (VtgProjectManagerOutputView* self, guint id);
void vtg_project_manager_output_view_clean_output (VtgProjectManagerOutputView* self);
void vtg_project_manager_output_view_log_message (VtgProjectManagerOutputView* self, const char* message);
void vtg_project_manager_output_view_activate (VtgProjectManagerOutputView* self);
VtgPlugin* vtg_project_manager_output_view_get_plugin (VtgProjectManagerOutputView* self);
GType vtg_project_manager_output_view_get_type (void);
GType vtg_project_manager_output_view_register_type (GTypeModule * module);


G_END_DECLS

#endif
