/*
 *  vtgprojectmanagermodulesdialog.vala - Vala developer toys for GEdit
 *  
 *  Copyright (C) 2008 - Andrea Del Signore <sejerpz@tin.it>
 *  
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *   
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *   
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330,
 *  Boston, MA 02111-1307, USA.
 */

#ifndef __VTGPROJECTMANAGERPACKAGESDIALOG_H__
#define __VTGPROJECTMANAGERPACKAGESDIALOG_H__

#include <glib.h>
#include <glib-object.h>
#include <gee/list.h>
#include "vtgprojectmanagerprojectmodule.h"

G_BEGIN_DECLS


#define VTG_PROJECT_MANAGER_TYPE_PACKAGES_DIALOG (vtg_project_manager_packages_dialog_get_type ())
#define VTG_PROJECT_MANAGER_PACKAGES_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VTG_PROJECT_MANAGER_TYPE_PACKAGES_DIALOG, VtgProjectManagerPackagesDialog))
#define VTG_PROJECT_MANAGER_PACKAGES_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VTG_PROJECT_MANAGER_TYPE_PACKAGES_DIALOG, VtgProjectManagerPackagesDialogClass))
#define VTG_PROJECT_MANAGER_IS_PACKAGES_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VTG_PROJECT_MANAGER_TYPE_PACKAGES_DIALOG))
#define VTG_PROJECT_MANAGER_IS_PACKAGES_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VTG_PROJECT_MANAGER_TYPE_PACKAGES_DIALOG))
#define VTG_PROJECT_MANAGER_PACKAGES_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VTG_PROJECT_MANAGER_TYPE_PACKAGES_DIALOG, VtgProjectManagerPackagesDialogClass))

typedef struct _VtgProjectManagerPackagesDialog VtgProjectManagerPackagesDialog;
typedef struct _VtgProjectManagerPackagesDialogClass VtgProjectManagerPackagesDialogClass;
typedef struct _VtgProjectManagerPackagesDialogPrivate VtgProjectManagerPackagesDialogPrivate;
typedef struct _VtgProjectManagerParamSpecPackagesDialog VtgProjectManagerParamSpecPackagesDialog;

struct _VtgProjectManagerPackagesDialog {
	GTypeInstance parent_instance;
	volatile int ref_count;
	VtgProjectManagerPackagesDialogPrivate * priv;
};

struct _VtgProjectManagerPackagesDialogClass {
	GTypeClass parent_class;
	void (*finalize) (VtgProjectManagerPackagesDialog *self);
};

struct _VtgProjectManagerParamSpecPackagesDialog {
	GParamSpec parent_instance;
};


VtgProjectManagerPackagesDialog* vtg_project_manager_packages_dialog_construct (GType object_type, VtgProjectManagerProjectModule* module, GeeList* modules);
VtgProjectManagerPackagesDialog* vtg_project_manager_packages_dialog_new (VtgProjectManagerProjectModule* module, GeeList* modules);
void vtg_project_manager_packages_dialog_show (VtgProjectManagerPackagesDialog* self);
GParamSpec* vtg_project_manager_param_spec_packages_dialog (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
gpointer vtg_project_manager_value_get_packages_dialog (const GValue* value);
void vtg_project_manager_value_set_packages_dialog (GValue* value, gpointer v_object);
GType vtg_project_manager_packages_dialog_get_type (void);
GType vtg_project_manager_packages_dialog_register_type (GTypeModule * module);
gpointer vtg_project_manager_packages_dialog_ref (gpointer instance);
void vtg_project_manager_packages_dialog_unref (gpointer instance);


G_END_DECLS

#endif
