/*
 *  vtgprojectmanagerprocesswatchinfo.vala - Vala developer toys for GEdit
 *  
 *  Copyright (C) 2008 - Andrea Del Signore <sejerpz@tin.it>
 *  
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *   
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *   
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330,
 *  Boston, MA 02111-1307, USA.
 */

#ifndef __VTGPROJECTMANAGERPROCESSWATCHINFO_H__
#define __VTGPROJECTMANAGERPROCESSWATCHINFO_H__

#include <glib.h>
#include <glib-object.h>

G_BEGIN_DECLS


#define VTG_PROJECT_MANAGER_TYPE_PROCESS_WATCH_INFO (vtg_project_manager_process_watch_info_get_type ())
#define VTG_PROJECT_MANAGER_PROCESS_WATCH_INFO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VTG_PROJECT_MANAGER_TYPE_PROCESS_WATCH_INFO, VtgProjectManagerProcessWatchInfo))
#define VTG_PROJECT_MANAGER_PROCESS_WATCH_INFO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VTG_PROJECT_MANAGER_TYPE_PROCESS_WATCH_INFO, VtgProjectManagerProcessWatchInfoClass))
#define VTG_PROJECT_MANAGER_IS_PROCESS_WATCH_INFO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VTG_PROJECT_MANAGER_TYPE_PROCESS_WATCH_INFO))
#define VTG_PROJECT_MANAGER_IS_PROCESS_WATCH_INFO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VTG_PROJECT_MANAGER_TYPE_PROCESS_WATCH_INFO))
#define VTG_PROJECT_MANAGER_PROCESS_WATCH_INFO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VTG_PROJECT_MANAGER_TYPE_PROCESS_WATCH_INFO, VtgProjectManagerProcessWatchInfoClass))

typedef struct _VtgProjectManagerProcessWatchInfo VtgProjectManagerProcessWatchInfo;
typedef struct _VtgProjectManagerProcessWatchInfoClass VtgProjectManagerProcessWatchInfoClass;
typedef struct _VtgProjectManagerProcessWatchInfoPrivate VtgProjectManagerProcessWatchInfoPrivate;
typedef struct _VtgProjectManagerParamSpecProcessWatchInfo VtgProjectManagerParamSpecProcessWatchInfo;

struct _VtgProjectManagerProcessWatchInfo {
	GTypeInstance parent_instance;
	volatile int ref_count;
	VtgProjectManagerProcessWatchInfoPrivate * priv;
	guint id;
	GIOChannel* stdin;
	GIOChannel* stdout;
	GIOChannel* stderr;
	guint stdout_watch_id;
	guint stderr_watch_id;
};

struct _VtgProjectManagerProcessWatchInfoClass {
	GTypeClass parent_class;
	void (*finalize) (VtgProjectManagerProcessWatchInfo *self);
};

struct _VtgProjectManagerParamSpecProcessWatchInfo {
	GParamSpec parent_instance;
};


VtgProjectManagerProcessWatchInfo* vtg_project_manager_process_watch_info_construct (GType object_type, guint id);
VtgProjectManagerProcessWatchInfo* vtg_project_manager_process_watch_info_new (guint id);
void vtg_project_manager_process_watch_info_cleanup (VtgProjectManagerProcessWatchInfo* self);
GParamSpec* vtg_project_manager_param_spec_process_watch_info (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
gpointer vtg_project_manager_value_get_process_watch_info (const GValue* value);
void vtg_project_manager_value_set_process_watch_info (GValue* value, gpointer v_object);
GType vtg_project_manager_process_watch_info_get_type (void);
GType vtg_project_manager_process_watch_info_register_type (GTypeModule * module);
gpointer vtg_project_manager_process_watch_info_ref (gpointer instance);
void vtg_project_manager_process_watch_info_unref (gpointer instance);


G_END_DECLS

#endif
