/*
 *  vtgprojectmanagerprojectgroup.vala - Vala developer toys for GEdit
 *  
 *  Copyright (C) 2008 - Andrea Del Signore <sejerpz@tin.it>
 *  
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *   
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *   
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330,
 *  Boston, MA 02111-1307, USA.
 */

#ifndef __VTGPROJECTMANAGERPROJECTGROUP_H__
#define __VTGPROJECTMANAGERPROJECTGROUP_H__

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gee/list.h>
#include "vtgprojectmanagerproject.h"

G_BEGIN_DECLS


#define VTG_PROJECT_MANAGER_TYPE_PROJECT_GROUP (vtg_project_manager_project_group_get_type ())
#define VTG_PROJECT_MANAGER_PROJECT_GROUP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VTG_PROJECT_MANAGER_TYPE_PROJECT_GROUP, VtgProjectManagerProjectGroup))
#define VTG_PROJECT_MANAGER_PROJECT_GROUP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VTG_PROJECT_MANAGER_TYPE_PROJECT_GROUP, VtgProjectManagerProjectGroupClass))
#define VTG_PROJECT_MANAGER_IS_PROJECT_GROUP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VTG_PROJECT_MANAGER_TYPE_PROJECT_GROUP))
#define VTG_PROJECT_MANAGER_IS_PROJECT_GROUP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VTG_PROJECT_MANAGER_TYPE_PROJECT_GROUP))
#define VTG_PROJECT_MANAGER_PROJECT_GROUP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VTG_PROJECT_MANAGER_TYPE_PROJECT_GROUP, VtgProjectManagerProjectGroupClass))

typedef struct _VtgProjectManagerProjectGroupPrivate VtgProjectManagerProjectGroupPrivate;

struct _VtgProjectManagerProjectGroup {
	GObject parent_instance;
	VtgProjectManagerProjectGroupPrivate * priv;
	char* name;
	char* id;
	GeeList* targets;
	GeeList* vapidirs;
	GeeList* packages;
	GeeList* built_libraries;
	VtgProjectManagerProject* project;
};

struct _VtgProjectManagerProjectGroupClass {
	GObjectClass parent_class;
};


VtgProjectManagerProjectGroup* vtg_project_manager_project_group_construct (GType object_type, const char* id, VtgProjectManagerProject* project);
VtgProjectManagerProjectGroup* vtg_project_manager_project_group_new (const char* id, VtgProjectManagerProject* project);
VtgProjectManagerProjectTarget* vtg_project_manager_project_group_find_target (VtgProjectManagerProjectGroup* self, const char* id);
GType vtg_project_manager_project_group_get_type (void);
GType vtg_project_manager_project_group_register_type (GTypeModule * module);


G_END_DECLS

#endif
