/*
 *  vtgprojectmanagerprojectmodule.vala - Vala developer toys for GEdit
 *  
 *  Copyright (C) 2008 - Andrea Del Signore <sejerpz@tin.it>
 *  
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *   
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *   
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330,
 *  Boston, MA 02111-1307, USA.
 */

#include "vtgprojectmanagerprojectmodule.h"
#include <gee/arraylist.h>
#include "vtgprojectmanagerprojectpackage.h"




struct _VtgProjectManagerProjectModulePrivate {
	VtgProjectManagerProject* _project;
};

#define VTG_PROJECT_MANAGER_PROJECT_MODULE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), VTG_PROJECT_MANAGER_TYPE_PROJECT_MODULE, VtgProjectManagerProjectModulePrivate))
enum  {
	VTG_PROJECT_MANAGER_PROJECT_MODULE_DUMMY_PROPERTY,
	VTG_PROJECT_MANAGER_PROJECT_MODULE_PROJECT
};
static gpointer vtg_project_manager_project_module_parent_class = NULL;
static void vtg_project_manager_project_module_finalize (GObject* obj);



VtgProjectManagerProjectModule* vtg_project_manager_project_module_construct (GType object_type, VtgProjectManagerProject* project, const char* name) {
	VtgProjectManagerProjectModule * self;
	char* _tmp1;
	const char* _tmp0;
	char* _tmp3;
	const char* _tmp2;
	VtgProjectManagerProject* _tmp5;
	VtgProjectManagerProject* _tmp4;
	g_return_val_if_fail (project != NULL, NULL);
	g_return_val_if_fail (name != NULL, NULL);
	self = g_object_newv (object_type, 0, NULL);
	_tmp1 = NULL;
	_tmp0 = NULL;
	self->name = (_tmp1 = (_tmp0 = name, (_tmp0 == NULL) ? NULL : g_strdup (_tmp0)), self->name = (g_free (self->name), NULL), _tmp1);
	_tmp3 = NULL;
	_tmp2 = NULL;
	self->id = (_tmp3 = (_tmp2 = name, (_tmp2 == NULL) ? NULL : g_strdup (_tmp2)), self->id = (g_free (self->id), NULL), _tmp3);
	_tmp5 = NULL;
	_tmp4 = NULL;
	self->priv->_project = (_tmp5 = (_tmp4 = project, (_tmp4 == NULL) ? NULL : g_object_ref (_tmp4)), (self->priv->_project == NULL) ? NULL : (self->priv->_project = (g_object_unref (self->priv->_project), NULL)), _tmp5);
	return self;
}


VtgProjectManagerProjectModule* vtg_project_manager_project_module_new (VtgProjectManagerProject* project, const char* name) {
	return vtg_project_manager_project_module_construct (VTG_PROJECT_MANAGER_TYPE_PROJECT_MODULE, project, name);
}


VtgProjectManagerProject* vtg_project_manager_project_module_get_project (VtgProjectManagerProjectModule* self) {
	g_return_val_if_fail (self != NULL, NULL);
	return self->priv->_project;
}


static void vtg_project_manager_project_module_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	VtgProjectManagerProjectModule * self;
	gpointer boxed;
	self = VTG_PROJECT_MANAGER_PROJECT_MODULE (object);
	switch (property_id) {
		case VTG_PROJECT_MANAGER_PROJECT_MODULE_PROJECT:
		g_value_set_object (value, vtg_project_manager_project_module_get_project (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void vtg_project_manager_project_module_class_init (VtgProjectManagerProjectModuleClass * klass) {
	vtg_project_manager_project_module_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (VtgProjectManagerProjectModulePrivate));
	G_OBJECT_CLASS (klass)->get_property = vtg_project_manager_project_module_get_property;
	G_OBJECT_CLASS (klass)->finalize = vtg_project_manager_project_module_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), VTG_PROJECT_MANAGER_PROJECT_MODULE_PROJECT, g_param_spec_object ("project", "project", "project", VTG_PROJECT_MANAGER_TYPE_PROJECT, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
}


static void vtg_project_manager_project_module_instance_init (VtgProjectManagerProjectModule * self) {
	self->priv = VTG_PROJECT_MANAGER_PROJECT_MODULE_GET_PRIVATE (self);
	self->packages = (GeeList*) gee_array_list_new (VTG_PROJECT_MANAGER_TYPE_PROJECT_PACKAGE, (GBoxedCopyFunc) g_object_ref, g_object_unref, g_direct_equal);
}


static void vtg_project_manager_project_module_finalize (GObject* obj) {
	VtgProjectManagerProjectModule * self;
	self = VTG_PROJECT_MANAGER_PROJECT_MODULE (obj);
	self->name = (g_free (self->name), NULL);
	self->id = (g_free (self->id), NULL);
	(self->packages == NULL) ? NULL : (self->packages = (gee_collection_object_unref (self->packages), NULL));
	(self->priv->_project == NULL) ? NULL : (self->priv->_project = (g_object_unref (self->priv->_project), NULL));
	G_OBJECT_CLASS (vtg_project_manager_project_module_parent_class)->finalize (obj);
}


static GType vtg_project_manager_project_module_type_id = 0;
GType vtg_project_manager_project_module_get_type (void) {
	return vtg_project_manager_project_module_type_id;
}


GType vtg_project_manager_project_module_register_type (GTypeModule * module) {
	static const GTypeInfo g_define_type_info = { sizeof (VtgProjectManagerProjectModuleClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vtg_project_manager_project_module_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (VtgProjectManagerProjectModule), 0, (GInstanceInitFunc) vtg_project_manager_project_module_instance_init, NULL };
	vtg_project_manager_project_module_type_id = g_type_module_register_type (module, G_TYPE_OBJECT, "VtgProjectManagerProjectModule", &g_define_type_info, 0);
	return vtg_project_manager_project_module_type_id;
}




