/*
 *  vtgprojectmanagerprojectmodule.vala - Vala developer toys for GEdit
 *  
 *  Copyright (C) 2008 - Andrea Del Signore <sejerpz@tin.it>
 *  
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *   
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *   
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330,
 *  Boston, MA 02111-1307, USA.
 */

#ifndef __VTGPROJECTMANAGERPROJECTMODULE_H__
#define __VTGPROJECTMANAGERPROJECTMODULE_H__

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gee/list.h>
#include "vtgprojectmanagerproject.h"

G_BEGIN_DECLS


#define VTG_PROJECT_MANAGER_TYPE_PROJECT_MODULE (vtg_project_manager_project_module_get_type ())
#define VTG_PROJECT_MANAGER_PROJECT_MODULE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VTG_PROJECT_MANAGER_TYPE_PROJECT_MODULE, VtgProjectManagerProjectModule))
#define VTG_PROJECT_MANAGER_PROJECT_MODULE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VTG_PROJECT_MANAGER_TYPE_PROJECT_MODULE, VtgProjectManagerProjectModuleClass))
#define VTG_PROJECT_MANAGER_IS_PROJECT_MODULE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VTG_PROJECT_MANAGER_TYPE_PROJECT_MODULE))
#define VTG_PROJECT_MANAGER_IS_PROJECT_MODULE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VTG_PROJECT_MANAGER_TYPE_PROJECT_MODULE))
#define VTG_PROJECT_MANAGER_PROJECT_MODULE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VTG_PROJECT_MANAGER_TYPE_PROJECT_MODULE, VtgProjectManagerProjectModuleClass))

typedef struct _VtgProjectManagerProjectModule VtgProjectManagerProjectModule;
typedef struct _VtgProjectManagerProjectModuleClass VtgProjectManagerProjectModuleClass;
typedef struct _VtgProjectManagerProjectModulePrivate VtgProjectManagerProjectModulePrivate;

struct _VtgProjectManagerProjectModule {
	GObject parent_instance;
	VtgProjectManagerProjectModulePrivate * priv;
	char* name;
	char* id;
	GeeList* packages;
};

struct _VtgProjectManagerProjectModuleClass {
	GObjectClass parent_class;
};


VtgProjectManagerProjectModule* vtg_project_manager_project_module_construct (GType object_type, VtgProjectManagerProject* project, const char* name);
VtgProjectManagerProjectModule* vtg_project_manager_project_module_new (VtgProjectManagerProject* project, const char* name);
VtgProjectManagerProject* vtg_project_manager_project_module_get_project (VtgProjectManagerProjectModule* self);
GType vtg_project_manager_project_module_get_type (void);
GType vtg_project_manager_project_module_register_type (GTypeModule * module);


G_END_DECLS

#endif
