/*
 *  vtgprojectmanagerprojectsource.vala - Vala developer toys for GEdit
 *  
 *  Copyright (C) 2008 - Andrea Del Signore <sejerpz@tin.it>
 *  
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *   
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *   
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330,
 *  Boston, MA 02111-1307, USA.
 */

#include "vtgprojectmanagerprojectpackage.h"




enum  {
	VTG_PROJECT_MANAGER_PROJECT_PACKAGE_DUMMY_PROPERTY
};
static gpointer vtg_project_manager_project_package_parent_class = NULL;
static void vtg_project_manager_project_package_finalize (GObject* obj);



VtgProjectManagerProjectPackage* vtg_project_manager_project_package_construct (GType object_type, const char* name) {
	VtgProjectManagerProjectPackage * self;
	char* _tmp1;
	const char* _tmp0;
	char* _tmp3;
	const char* _tmp2;
	g_return_val_if_fail (name != NULL, NULL);
	self = g_object_newv (object_type, 0, NULL);
	_tmp1 = NULL;
	_tmp0 = NULL;
	self->name = (_tmp1 = (_tmp0 = name, (_tmp0 == NULL) ? NULL : g_strdup (_tmp0)), self->name = (g_free (self->name), NULL), _tmp1);
	_tmp3 = NULL;
	_tmp2 = NULL;
	self->id = (_tmp3 = (_tmp2 = name, (_tmp2 == NULL) ? NULL : g_strdup (_tmp2)), self->id = (g_free (self->id), NULL), _tmp3);
	return self;
}


VtgProjectManagerProjectPackage* vtg_project_manager_project_package_new (const char* name) {
	return vtg_project_manager_project_package_construct (VTG_PROJECT_MANAGER_TYPE_PROJECT_PACKAGE, name);
}


static void vtg_project_manager_project_package_class_init (VtgProjectManagerProjectPackageClass * klass) {
	vtg_project_manager_project_package_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->finalize = vtg_project_manager_project_package_finalize;
}


static void vtg_project_manager_project_package_instance_init (VtgProjectManagerProjectPackage * self) {
}


static void vtg_project_manager_project_package_finalize (GObject* obj) {
	VtgProjectManagerProjectPackage * self;
	self = VTG_PROJECT_MANAGER_PROJECT_PACKAGE (obj);
	self->name = (g_free (self->name), NULL);
	self->id = (g_free (self->id), NULL);
	G_OBJECT_CLASS (vtg_project_manager_project_package_parent_class)->finalize (obj);
}


static GType vtg_project_manager_project_package_type_id = 0;
GType vtg_project_manager_project_package_get_type (void) {
	return vtg_project_manager_project_package_type_id;
}


GType vtg_project_manager_project_package_register_type (GTypeModule * module) {
	static const GTypeInfo g_define_type_info = { sizeof (VtgProjectManagerProjectPackageClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vtg_project_manager_project_package_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (VtgProjectManagerProjectPackage), 0, (GInstanceInitFunc) vtg_project_manager_project_package_instance_init, NULL };
	vtg_project_manager_project_package_type_id = g_type_module_register_type (module, G_TYPE_OBJECT, "VtgProjectManagerProjectPackage", &g_define_type_info, 0);
	return vtg_project_manager_project_package_type_id;
}




