/*
 *  vtgprojectmanagerprojectsource.vala - Vala developer toys for GEdit
 *  
 *  Copyright (C) 2008 - Andrea Del Signore <sejerpz@tin.it>
 *  
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *   
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *   
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330,
 *  Boston, MA 02111-1307, USA.
 */

#ifndef __VTGPROJECTMANAGERPROJECTPACKAGE_H__
#define __VTGPROJECTMANAGERPROJECTPACKAGE_H__

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>

G_BEGIN_DECLS


#define VTG_PROJECT_MANAGER_TYPE_PROJECT_PACKAGE (vtg_project_manager_project_package_get_type ())
#define VTG_PROJECT_MANAGER_PROJECT_PACKAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VTG_PROJECT_MANAGER_TYPE_PROJECT_PACKAGE, VtgProjectManagerProjectPackage))
#define VTG_PROJECT_MANAGER_PROJECT_PACKAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VTG_PROJECT_MANAGER_TYPE_PROJECT_PACKAGE, VtgProjectManagerProjectPackageClass))
#define VTG_PROJECT_MANAGER_IS_PROJECT_PACKAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VTG_PROJECT_MANAGER_TYPE_PROJECT_PACKAGE))
#define VTG_PROJECT_MANAGER_IS_PROJECT_PACKAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VTG_PROJECT_MANAGER_TYPE_PROJECT_PACKAGE))
#define VTG_PROJECT_MANAGER_PROJECT_PACKAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VTG_PROJECT_MANAGER_TYPE_PROJECT_PACKAGE, VtgProjectManagerProjectPackageClass))

typedef struct _VtgProjectManagerProjectPackage VtgProjectManagerProjectPackage;
typedef struct _VtgProjectManagerProjectPackageClass VtgProjectManagerProjectPackageClass;
typedef struct _VtgProjectManagerProjectPackagePrivate VtgProjectManagerProjectPackagePrivate;

struct _VtgProjectManagerProjectPackage {
	GObject parent_instance;
	VtgProjectManagerProjectPackagePrivate * priv;
	char* name;
	char* id;
};

struct _VtgProjectManagerProjectPackageClass {
	GObjectClass parent_class;
};


VtgProjectManagerProjectPackage* vtg_project_manager_project_package_construct (GType object_type, const char* name);
VtgProjectManagerProjectPackage* vtg_project_manager_project_package_new (const char* name);
GType vtg_project_manager_project_package_get_type (void);
GType vtg_project_manager_project_package_register_type (GTypeModule * module);


G_END_DECLS

#endif
