/*
 *  vtgprojectmanagerprojectsource.vala - Vala developer toys for GEdit
 *  
 *  Copyright (C) 2008 - Andrea Del Signore <sejerpz@tin.it>
 *  
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *   
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *   
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330,
 *  Boston, MA 02111-1307, USA.
 */

#include "vtgprojectmanagerprojectsource.h"




enum  {
	VTG_PROJECT_MANAGER_PROJECT_SOURCE_DUMMY_PROPERTY
};
static gpointer vtg_project_manager_project_source_parent_class = NULL;
static void vtg_project_manager_project_source_finalize (GObject* obj);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);



VtgProjectManagerProjectSource* vtg_project_manager_project_source_construct (GType object_type, const char* uri) {
	VtgProjectManagerProjectSource * self;
	char* _tmp1;
	const char* _tmp0;
	char** _tmp3;
	gint tmp_size;
	gint tmp_length1;
	char** _tmp2;
	char** tmp;
	gint count;
	gboolean _tmp8;
	g_return_val_if_fail (uri != NULL, NULL);
	self = g_object_newv (object_type, 0, NULL);
	_tmp1 = NULL;
	_tmp0 = NULL;
	self->uri = (_tmp1 = (_tmp0 = uri, (_tmp0 == NULL) ? NULL : g_strdup (_tmp0)), self->uri = (g_free (self->uri), NULL), _tmp1);
	_tmp3 = NULL;
	_tmp2 = NULL;
	tmp = (_tmp3 = _tmp2 = g_strsplit (self->uri, "/", 0), tmp_length1 = _vala_array_length (_tmp2), tmp_size = tmp_length1, _tmp3);
	count = 0;
	while (tmp[count] != NULL) {
		count++;
	}
	if (count == 0) {
		char* _tmp5;
		const char* _tmp4;
		_tmp5 = NULL;
		_tmp4 = NULL;
		self->name = (_tmp5 = (_tmp4 = uri, (_tmp4 == NULL) ? NULL : g_strdup (_tmp4)), self->name = (g_free (self->name), NULL), _tmp5);
	} else {
		char* _tmp7;
		const char* _tmp6;
		_tmp7 = NULL;
		_tmp6 = NULL;
		self->name = (_tmp7 = (_tmp6 = tmp[count - 1], (_tmp6 == NULL) ? NULL : g_strdup (_tmp6)), self->name = (g_free (self->name), NULL), _tmp7);
	}
	_tmp8 = FALSE;
	if (g_str_has_suffix (uri, ".vala")) {
		_tmp8 = TRUE;
	} else {
		_tmp8 = g_str_has_suffix (uri, ".vapi");
	}
	if (_tmp8) {
		self->is_vala_source = TRUE;
	} else {
		self->is_vala_source = FALSE;
	}
	return self;
}


VtgProjectManagerProjectSource* vtg_project_manager_project_source_new (const char* uri) {
	return vtg_project_manager_project_source_construct (VTG_PROJECT_MANAGER_TYPE_PROJECT_SOURCE, uri);
}


static void vtg_project_manager_project_source_class_init (VtgProjectManagerProjectSourceClass * klass) {
	vtg_project_manager_project_source_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->finalize = vtg_project_manager_project_source_finalize;
}


static void vtg_project_manager_project_source_instance_init (VtgProjectManagerProjectSource * self) {
}


static void vtg_project_manager_project_source_finalize (GObject* obj) {
	VtgProjectManagerProjectSource * self;
	self = VTG_PROJECT_MANAGER_PROJECT_SOURCE (obj);
	self->uri = (g_free (self->uri), NULL);
	self->name = (g_free (self->name), NULL);
	G_OBJECT_CLASS (vtg_project_manager_project_source_parent_class)->finalize (obj);
}


static GType vtg_project_manager_project_source_type_id = 0;
GType vtg_project_manager_project_source_get_type (void) {
	return vtg_project_manager_project_source_type_id;
}


GType vtg_project_manager_project_source_register_type (GTypeModule * module) {
	static const GTypeInfo g_define_type_info = { sizeof (VtgProjectManagerProjectSourceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vtg_project_manager_project_source_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (VtgProjectManagerProjectSource), 0, (GInstanceInitFunc) vtg_project_manager_project_source_instance_init, NULL };
	vtg_project_manager_project_source_type_id = g_type_module_register_type (module, G_TYPE_OBJECT, "VtgProjectManagerProjectSource", &g_define_type_info, 0);
	return vtg_project_manager_project_source_type_id;
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}




