/*
 *  vtgprojectmanagerprojecttarget.vala - Vala developer toys for GEdit
 *  
 *  Copyright (C) 2008 - Andrea Del Signore <sejerpz@tin.it>
 *  
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *   
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *   
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330,
 *  Boston, MA 02111-1307, USA.
 */

#ifndef __VTGPROJECTMANAGERPROJECTTARGET_H__
#define __VTGPROJECTMANAGERPROJECTTARGET_H__

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gee/list.h>
#include "vtgprojectmanagerproject.h"
#include "vtgprojectmanagerprojectsource.h"

G_BEGIN_DECLS


#define VTG_PROJECT_MANAGER_TYPE_TARGET_TYPES (vtg_project_manager_target_types_get_type ())

#define VTG_PROJECT_MANAGER_TYPE_PROJECT_TARGET (vtg_project_manager_project_target_get_type ())
#define VTG_PROJECT_MANAGER_PROJECT_TARGET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VTG_PROJECT_MANAGER_TYPE_PROJECT_TARGET, VtgProjectManagerProjectTarget))
#define VTG_PROJECT_MANAGER_PROJECT_TARGET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VTG_PROJECT_MANAGER_TYPE_PROJECT_TARGET, VtgProjectManagerProjectTargetClass))
#define VTG_PROJECT_MANAGER_IS_PROJECT_TARGET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VTG_PROJECT_MANAGER_TYPE_PROJECT_TARGET))
#define VTG_PROJECT_MANAGER_IS_PROJECT_TARGET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VTG_PROJECT_MANAGER_TYPE_PROJECT_TARGET))
#define VTG_PROJECT_MANAGER_PROJECT_TARGET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VTG_PROJECT_MANAGER_TYPE_PROJECT_TARGET, VtgProjectManagerProjectTargetClass))

typedef struct _VtgProjectManagerProjectTargetPrivate VtgProjectManagerProjectTargetPrivate;

typedef enum  {
	VTG_PROJECT_MANAGER_TARGET_TYPES_UNKNOWN,
	VTG_PROJECT_MANAGER_TARGET_TYPES_SHARED_LIBRARY,
	VTG_PROJECT_MANAGER_TARGET_TYPES_STATIC_LIBRARY,
	VTG_PROJECT_MANAGER_TARGET_TYPES_EXECUTABLE
} VtgProjectManagerTargetTypes;

struct _VtgProjectManagerProjectTarget {
	GObject parent_instance;
	VtgProjectManagerProjectTargetPrivate * priv;
	char* name;
	char* id;
	GeeList* sources;
	gboolean vala_sources;
	gboolean generated_sources;
	VtgProjectManagerTargetTypes type;
	VtgProjectManagerProjectGroup* group;
};

struct _VtgProjectManagerProjectTargetClass {
	GObjectClass parent_class;
};


GType vtg_project_manager_target_types_get_type (void);
VtgProjectManagerProjectTarget* vtg_project_manager_project_target_construct (GType object_type, const char* id, VtgProjectManagerProjectGroup* group);
VtgProjectManagerProjectTarget* vtg_project_manager_project_target_new (const char* id, VtgProjectManagerProjectGroup* group);
void vtg_project_manager_project_target_add_source (VtgProjectManagerProjectTarget* self, VtgProjectManagerProjectSource* source);
VtgProjectManagerProjectSource* vtg_project_manager_project_target_find_source (VtgProjectManagerProjectTarget* self, const char* uri);
void vtg_project_manager_project_target_set_type_from_string (VtgProjectManagerProjectTarget* self, const char* data);
gboolean vtg_project_manager_project_target_get_simple (VtgProjectManagerProjectTarget* self);
GType vtg_project_manager_project_target_get_type (void);
GType vtg_project_manager_project_target_register_type (GTypeModule * module);


G_END_DECLS

#endif
