/*
 *  vtgprojectmanagerview.vala - Vala developer toys for GEdit
 *  
 *  Copyright (C) 2008 - Andrea Del Signore <sejerpz@tin.it>
 *  
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *   
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *   
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330,
 *  Boston, MA 02111-1307, USA.
 */

#ifndef __VTGPROJECTMANAGERVIEW_H__
#define __VTGPROJECTMANAGERVIEW_H__

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include "vtgplugin.h"
#include "vtgprojectmanagerproject.h"

G_BEGIN_DECLS


#define VTG_PROJECT_MANAGER_TYPE_VIEW (vtg_project_manager_view_get_type ())
#define VTG_PROJECT_MANAGER_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VTG_PROJECT_MANAGER_TYPE_VIEW, VtgProjectManagerView))
#define VTG_PROJECT_MANAGER_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VTG_PROJECT_MANAGER_TYPE_VIEW, VtgProjectManagerViewClass))
#define VTG_PROJECT_MANAGER_IS_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VTG_PROJECT_MANAGER_TYPE_VIEW))
#define VTG_PROJECT_MANAGER_IS_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VTG_PROJECT_MANAGER_TYPE_VIEW))
#define VTG_PROJECT_MANAGER_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VTG_PROJECT_MANAGER_TYPE_VIEW, VtgProjectManagerViewClass))

typedef struct _VtgProjectManagerViewPrivate VtgProjectManagerViewPrivate;

struct _VtgProjectManagerView {
	GObject parent_instance;
	VtgProjectManagerViewPrivate * priv;
};

struct _VtgProjectManagerViewClass {
	GObjectClass parent_class;
};


VtgProjectManagerView* vtg_project_manager_view_construct (GType object_type, VtgPlugin* plugin);
VtgProjectManagerView* vtg_project_manager_view_new (VtgPlugin* plugin);
void vtg_project_manager_view_add_project (VtgProjectManagerView* self, VtgProjectManagerProject* project);
void vtg_project_manager_view_remove_project (VtgProjectManagerView* self, VtgProjectManagerProject* project);
void vtg_project_manager_view_on_project_view_row_activated (VtgProjectManagerView* self, GtkWidget* sender, const GtkTreePath* path, GtkTreeViewColumn* column);
gboolean vtg_project_manager_view_on_project_view_button_press (VtgProjectManagerView* self, GtkWidget* sender, const GdkEventButton* event);
void vtg_project_manager_view_on_project_combobox_changed (VtgProjectManagerView* self, GtkWidget* sender);
VtgProjectManagerProject* vtg_project_manager_view_get_current_project (VtgProjectManagerView* self);
void vtg_project_manager_view_set_current_project (VtgProjectManagerView* self, VtgProjectManagerProject* value);
GType vtg_project_manager_view_get_type (void);
GType vtg_project_manager_view_register_type (GTypeModule * module);


G_END_DECLS

#endif
