/*
 *  vtgsymbolcompletionhelper.vala - Vala developer toys for GEdit
 *  
 *  Copyright (C) 2008 - Andrea Del Signore <sejerpz@tin.it>
 *  
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *   
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *   
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330,
 *  Boston, MA 02111-1307, USA.
 */

#ifndef __VTGSYMBOLCOMPLETIONHELPER_H__
#define __VTGSYMBOLCOMPLETIONHELPER_H__

#include <glib.h>
#include <glib-object.h>
#include <gedit/gedit-view.h>
#include <vscsymbolcompletion.h>
#include "vtgplugin.h"
#include "vtgsymbolcompletiontrigger.h"

G_BEGIN_DECLS


#define VTG_TYPE_SYMBOL_COMPLETION_HELPER (vtg_symbol_completion_helper_get_type ())
#define VTG_SYMBOL_COMPLETION_HELPER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VTG_TYPE_SYMBOL_COMPLETION_HELPER, VtgSymbolCompletionHelper))
#define VTG_SYMBOL_COMPLETION_HELPER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VTG_TYPE_SYMBOL_COMPLETION_HELPER, VtgSymbolCompletionHelperClass))
#define VTG_IS_SYMBOL_COMPLETION_HELPER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VTG_TYPE_SYMBOL_COMPLETION_HELPER))
#define VTG_IS_SYMBOL_COMPLETION_HELPER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VTG_TYPE_SYMBOL_COMPLETION_HELPER))
#define VTG_SYMBOL_COMPLETION_HELPER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VTG_TYPE_SYMBOL_COMPLETION_HELPER, VtgSymbolCompletionHelperClass))

typedef struct _VtgSymbolCompletionHelperPrivate VtgSymbolCompletionHelperPrivate;

struct _VtgSymbolCompletionHelper {
	GObject parent_instance;
	VtgSymbolCompletionHelperPrivate * priv;
};

struct _VtgSymbolCompletionHelperClass {
	GObjectClass parent_class;
};


VtgSymbolCompletionHelper* vtg_symbol_completion_helper_construct (GType object_type, VtgPlugin* plugin, GeditView* view, VscSymbolCompletion* completion);
VtgSymbolCompletionHelper* vtg_symbol_completion_helper_new (VtgPlugin* plugin, GeditView* view, VscSymbolCompletion* completion);
void vtg_symbol_completion_helper_deactivate (VtgSymbolCompletionHelper* self);
VtgPlugin* vtg_symbol_completion_helper_get_plugin (VtgSymbolCompletionHelper* self);
GeditView* vtg_symbol_completion_helper_get_view (VtgSymbolCompletionHelper* self);
VscSymbolCompletion* vtg_symbol_completion_helper_get_completion (VtgSymbolCompletionHelper* self);
VtgSymbolCompletionTrigger* vtg_symbol_completion_helper_get_trigger (VtgSymbolCompletionHelper* self);
GType vtg_symbol_completion_helper_get_type (void);
GType vtg_symbol_completion_helper_register_type (GTypeModule * module);


G_END_DECLS

#endif
