/*
 *  vtgsymbolcompletionprovider.vala - Vala developer toys for GEdit
 *  
 *  Copyright (C) 2008 - Andrea Del Signore <sejerpz@tin.it>
 *  
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *   
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *   
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330,
 *  Boston, MA 02111-1307, USA.
 */

#ifndef __VTGSYMBOLCOMPLETIONPROVIDER_H__
#define __VTGSYMBOLCOMPLETIONPROVIDER_H__

#include <glib.h>
#include <glib-object.h>
#include <gtksourcecompletion/gsc-provider.h>
#include <gedit/gedit-view.h>
#include <vscsymbolcompletion.h>
#include <stdlib.h>
#include <string.h>
#include <gtksourcecompletion/gsc-trigger.h>
#include "vtgplugin.h"

G_BEGIN_DECLS


#define VTG_TYPE_SYMBOL_COMPLETION_PROVIDER (vtg_symbol_completion_provider_get_type ())
#define VTG_SYMBOL_COMPLETION_PROVIDER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VTG_TYPE_SYMBOL_COMPLETION_PROVIDER, VtgSymbolCompletionProvider))
#define VTG_SYMBOL_COMPLETION_PROVIDER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VTG_TYPE_SYMBOL_COMPLETION_PROVIDER, VtgSymbolCompletionProviderClass))
#define VTG_IS_SYMBOL_COMPLETION_PROVIDER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VTG_TYPE_SYMBOL_COMPLETION_PROVIDER))
#define VTG_IS_SYMBOL_COMPLETION_PROVIDER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VTG_TYPE_SYMBOL_COMPLETION_PROVIDER))
#define VTG_SYMBOL_COMPLETION_PROVIDER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VTG_TYPE_SYMBOL_COMPLETION_PROVIDER, VtgSymbolCompletionProviderClass))

typedef struct _VtgSymbolCompletionProvider VtgSymbolCompletionProvider;
typedef struct _VtgSymbolCompletionProviderClass VtgSymbolCompletionProviderClass;
typedef struct _VtgSymbolCompletionProviderPrivate VtgSymbolCompletionProviderPrivate;

struct _VtgSymbolCompletionProvider {
	GObject parent_instance;
	VtgSymbolCompletionProviderPrivate * priv;
};

struct _VtgSymbolCompletionProviderClass {
	GObjectClass parent_class;
};


VtgSymbolCompletionProvider* vtg_symbol_completion_provider_construct (GType object_type, VtgPlugin* plugin, GeditView* view, VscSymbolCompletion* completion);
VtgSymbolCompletionProvider* vtg_symbol_completion_provider_new (VtgPlugin* plugin, GeditView* view, VscSymbolCompletion* completion);
GType vtg_symbol_completion_provider_get_type (void);
GType vtg_symbol_completion_provider_register_type (GTypeModule * module);


G_END_DECLS

#endif
