/*
 *  vtgsymbolcompletiontrigger.vala - Vala developer toys for GEdit
 *  
 *  Copyright (C) 2008 - Andrea Del Signore <sejerpz@tin.it>
 *  
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *   
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *   
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330,
 *  Boston, MA 02111-1307, USA.
 */

#ifndef __VTGSYMBOLCOMPLETIONTRIGGER_H__
#define __VTGSYMBOLCOMPLETIONTRIGGER_H__

#include <glib.h>
#include <glib-object.h>
#include <gtksourcecompletion/gsc-trigger.h>
#include <stdlib.h>
#include <string.h>
#include <gtksourcecompletion/gsc-manager.h>

G_BEGIN_DECLS


#define VTG_TYPE_SYMBOL_COMPLETION_TRIGGER (vtg_symbol_completion_trigger_get_type ())
#define VTG_SYMBOL_COMPLETION_TRIGGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VTG_TYPE_SYMBOL_COMPLETION_TRIGGER, VtgSymbolCompletionTrigger))
#define VTG_SYMBOL_COMPLETION_TRIGGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VTG_TYPE_SYMBOL_COMPLETION_TRIGGER, VtgSymbolCompletionTriggerClass))
#define VTG_IS_SYMBOL_COMPLETION_TRIGGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VTG_TYPE_SYMBOL_COMPLETION_TRIGGER))
#define VTG_IS_SYMBOL_COMPLETION_TRIGGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VTG_TYPE_SYMBOL_COMPLETION_TRIGGER))
#define VTG_SYMBOL_COMPLETION_TRIGGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VTG_TYPE_SYMBOL_COMPLETION_TRIGGER, VtgSymbolCompletionTriggerClass))

typedef struct _VtgSymbolCompletionTrigger VtgSymbolCompletionTrigger;
typedef struct _VtgSymbolCompletionTriggerClass VtgSymbolCompletionTriggerClass;
typedef struct _VtgSymbolCompletionTriggerPrivate VtgSymbolCompletionTriggerPrivate;

struct _VtgSymbolCompletionTrigger {
	GObject parent_instance;
	VtgSymbolCompletionTriggerPrivate * priv;
	gboolean shortcut_triggered;
};

struct _VtgSymbolCompletionTriggerClass {
	GObjectClass parent_class;
};


void vtg_symbol_completion_trigger_complete_word (VtgSymbolCompletionTrigger* self);
void vtg_symbol_completion_trigger_trigger_event (VtgSymbolCompletionTrigger* self, gboolean trigger_reason);
VtgSymbolCompletionTrigger* vtg_symbol_completion_trigger_construct (GType object_type, GscManager* completion, const char* trigger_name);
VtgSymbolCompletionTrigger* vtg_symbol_completion_trigger_new (GscManager* completion, const char* trigger_name);
GscManager* vtg_symbol_completion_trigger_get_completion (VtgSymbolCompletionTrigger* self);
GType vtg_symbol_completion_trigger_get_type (void);
GType vtg_symbol_completion_trigger_register_type (GTypeModule * module);


G_END_DECLS

#endif
