/*
 *  vtgvcsbackendsivcs.vala - Vala developer toys for GEdit
 *  
 *  Copyright (C) 2008 - Andrea Del Signore <sejerpz@tin.it>
 *  
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *   
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *   
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330,
 *  Boston, MA 02111-1307, USA.
 */

#ifndef __VTGVCSBACKENDSIVCS_H__
#define __VTGVCSBACKENDSIVCS_H__

#include <glib.h>
#include <glib-object.h>
#include <gee/list.h>
#include <stdlib.h>
#include <string.h>

G_BEGIN_DECLS


#define VTG_VCS_BACKENDS_TYPE_STATES (vtg_vcs_backends_states_get_type ())

#define VTG_VCS_BACKENDS_TYPE_ITEM (vtg_vcs_backends_item_get_type ())
#define VTG_VCS_BACKENDS_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VTG_VCS_BACKENDS_TYPE_ITEM, VtgVcsBackendsItem))
#define VTG_VCS_BACKENDS_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VTG_VCS_BACKENDS_TYPE_ITEM, VtgVcsBackendsItemClass))
#define VTG_VCS_BACKENDS_IS_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VTG_VCS_BACKENDS_TYPE_ITEM))
#define VTG_VCS_BACKENDS_IS_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VTG_VCS_BACKENDS_TYPE_ITEM))
#define VTG_VCS_BACKENDS_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VTG_VCS_BACKENDS_TYPE_ITEM, VtgVcsBackendsItemClass))

typedef struct _VtgVcsBackendsItem VtgVcsBackendsItem;
typedef struct _VtgVcsBackendsItemClass VtgVcsBackendsItemClass;
typedef struct _VtgVcsBackendsItemPrivate VtgVcsBackendsItemPrivate;
typedef struct _VtgVcsBackendsParamSpecItem VtgVcsBackendsParamSpecItem;

#define VTG_VCS_BACKENDS_TYPE_IVCS (vtg_vcs_backends_ivcs_get_type ())
#define VTG_VCS_BACKENDS_IVCS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VTG_VCS_BACKENDS_TYPE_IVCS, VtgVcsBackendsIVcs))
#define VTG_VCS_BACKENDS_IS_IVCS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VTG_VCS_BACKENDS_TYPE_IVCS))
#define VTG_VCS_BACKENDS_IVCS_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), VTG_VCS_BACKENDS_TYPE_IVCS, VtgVcsBackendsIVcsIface))

typedef struct _VtgVcsBackendsIVcs VtgVcsBackendsIVcs;
typedef struct _VtgVcsBackendsIVcsIface VtgVcsBackendsIVcsIface;

typedef enum  {
	VTG_VCS_BACKENDS_STATES_UNTRACKED,
	VTG_VCS_BACKENDS_STATES_ADDED,
	VTG_VCS_BACKENDS_STATES_MODIFIED
} VtgVcsBackendsStates;

struct _VtgVcsBackendsItem {
	GTypeInstance parent_instance;
	volatile int ref_count;
	VtgVcsBackendsItemPrivate * priv;
	char* name;
	VtgVcsBackendsStates state;
};

struct _VtgVcsBackendsItemClass {
	GTypeClass parent_class;
	void (*finalize) (VtgVcsBackendsItem *self);
};

struct _VtgVcsBackendsParamSpecItem {
	GParamSpec parent_instance;
};

typedef enum  {
	VTG_VCS_BACKENDS_VCS_ERROR_CommandFailed
} VtgVcsBackendsVcsError;
#define VTG_VCS_BACKENDS_VCS_ERROR vtg_vcs_backends_vcs_error_quark ()
struct _VtgVcsBackendsIVcsIface {
	GTypeInterface parent_iface;
	GeeList* (*get_items) (VtgVcsBackendsIVcs* self, const char* path, GError** error);
	gboolean (*test) (VtgVcsBackendsIVcs* self, const char* path);
};


GType vtg_vcs_backends_states_get_type (void);
VtgVcsBackendsItem* vtg_vcs_backends_item_construct (GType object_type);
VtgVcsBackendsItem* vtg_vcs_backends_item_new (void);
GParamSpec* vtg_vcs_backends_param_spec_item (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
gpointer vtg_vcs_backends_value_get_item (const GValue* value);
void vtg_vcs_backends_value_set_item (GValue* value, gpointer v_object);
GType vtg_vcs_backends_item_get_type (void);
GType vtg_vcs_backends_item_register_type (GTypeModule * module);
gpointer vtg_vcs_backends_item_ref (gpointer instance);
void vtg_vcs_backends_item_unref (gpointer instance);
GQuark vtg_vcs_backends_vcs_error_quark (void);
GeeList* vtg_vcs_backends_ivcs_get_items (VtgVcsBackendsIVcs* self, const char* path, GError** error);
gboolean vtg_vcs_backends_ivcs_test (VtgVcsBackendsIVcs* self, const char* path);
GType vtg_vcs_backends_ivcs_get_type (void);


G_END_DECLS

#endif
